# Building PyQt5 - Version 5.8.1
[<-- Main 'Table of content'](Home#table_of_content)
 
[<-- 'Building of QGIS 3.* versions'](Building-QGIS-3#topics)

[<-- 'Building QGIS 3.0 from scratch'](Building-QGIS-3.0-from-scratch#topics)

[<-- 'Building QT 5 from scratch'](Building-QT-5-from-scratch#topics)


***


[--> 'Download the source'](#download_source)

[--> 'Configuration'](#configuration)

[--> 'Build and install'](#build)

[--> 'QGIS 3 ccmake parms'](#qgis_ccmake_parms)

---

The original instructions can be found here:
* ['Installing PyQt5'](http://pyqt.sourceforge.net/Docs/PyQt5/installation.html)

---

**Download the source**
<a name="download_source"/>

The source code can be downloaded from this site:
* ['PyQt5 Download'](https://www.riverbankcomputing.com/software/pyqt/download5)

or with the wget command:
* `wget https://sourceforge.net/projects/pyqt/files/PyQt5/PyQt-5.8.1/PyQt5_gpl-5.8.1.tar.gz`

***
Unpack the source from the archive.

***
**Configuration**
<a name="configuration"/>

**Note:** pre-condition is that: **QT 5** has been installed and
* that the the all important **qmake** is available
   * in my case in */home/mj10777/000_links/apps_local/libQt571/bin/qmake*
* [that SIP has been installed](Building-SIP-for-QT-5)

Enter the directory when the source-code was unpacked
```c
cd PyQt5_gpl-5.8.1
```

Inside this directory, you should find:
* **configure.py**

With
**python3 configure.py --help**  all of the available parameters can be listed, such as:

* **--confirm-license** [where the results should be stored]
* **--qmake** [where the all important **qmake** is stored]

```c
/home/mj10777/000_links/apps_local/libQt571/bin/python3 configure.py --confirm-license --qmake=/home/mj10777/000_links/apps_local/libQt571/bin/qmake
```

The script will issue message that will look something like this:

```c
The qmake executable is /home/mj10777/000_links/apps_local/libQt571/bin/qmake.
Qt is built as a shared library.
SIP 4.19.1 is being used.
The sip executable is /usr/bin/sip.
These PyQt5 modules will be built: QtCore, QtGui, QtHelp, QtMultimedia,
QtMultimediaWidgets, QtNetwork, QtOpenGL, QtPrintSupport, QtQml, QtQuick,
QtSql, QtSvg, QtTest, QtWebKit, QtWebKitWidgets, QtWidgets, QtXml,
QtXmlPatterns, QtDesigner, QtDBus, _QOpenGLFunctions_2_0,
_QOpenGLFunctions_2_1, _QOpenGLFunctions_4_1_Core, QtSensors, QtSerialPort,
QtX11Extras, QtBluetooth, QtPositioning, QtQuickWidgets, QtWebSockets,
QtWebChannel, QtLocation, QtNfc.
The PyQt5 Python package will be installed in
/home/mj10777/000_links/apps_local/libQt571/lib/python3.4/site-packages.
PyQt5 is being built with generated docstrings.
PyQt5 is being built with 'protected' redefined as 'public'.
The Designer plugin will be installed in
/home/mj10777/000_links/apps_local/libQt571/plugins/designer.
The qmlscene plugin will be installed in
/home/mj10777/000_links/apps_local/libQt571/plugins/PyQt5.
The QScintilla API file will be installed in
/home/mj10777/000_links/apps_local/libQt571/qsci/api/python.
The PyQt5 .sip files will be installed in
/home/mj10777/000_links/apps_local/libQt571/share/sip/PyQt5.
pyuic5, pyrcc5 and pylupdate5 will be installed in
/home/mj10777/gnu_source/qt_dev/PyQt5/PyQt5_gpl-5.8.1/indir=/home/mj10777/000_links/apps_local/libQt571/bin.
The interpreter used by pyuic5 is
/home/mj10777/000_links/apps_local/libQt571/bin/python3.
```

***

**Build and install**
<a name="build"/>

```c
make
```

If this runs without error
* **Note:** in this scenario **sudo** is not needed

```c
make install
```

***

**QGIS 3 ccmake parms**
<a name="qgis_ccmake_parms"/>

For the QGIS 3 Project, these values for the library and include directories must be properly set using **ccmake**:

* **QSCI_SIP_DIR** : /home/mj10777/000_links/apps_local/libQt571/share/sip/**PyQt5**

---
2017-03-18: Mark Johnson, Berlin Germany

---