# Building QCA for QT 5 - Version 2.1.3
[<-- Main 'Table of content'](Home#table_of_content)
 
[<-- 'Building of QGIS 3.* versions'](Building-QGIS-3#topics)

[<-- 'Building QGIS 3.0 from scratch'](Building-QGIS-3.0-from-scratch#topics)

[<-- 'Building QT 5 from scratch'](Building-QT-5-from-scratch#topics)


***


[--> 'Download the source'](#download_source)

[--> 'Configuration'](#configuration)

[--> 'Build and install'](#build)

[--> 'QGIS 3 ccmake parms'](#qgis_ccmake_parms)

[--> 'QGIS 3 ccmake parms'](#qgis_ccmake_parms)

---

**Download the source**
<a name="download_source"/>

The source code can be downloaded from this site
* ['KDE UserBase Wiki - QCA'](https://userbase.kde.org/QCA)

or with the wget command:
* `wget http://download.kde.org/stable/qca/2.1.3/src/qca-2.1.3.tar.xz`


***
Unpack the source from the archive.

**Note:** to avoid the following error:
* #error Qt requires a C++11 compiler and yours does not seem to be that.

add the following statement to the qca-2.1.3/CMakeLists.txt file
```c
add_compile_options(-std=c++11)
```

***
**Configuration**
<a name="configuration"/>

```c
mkdir build_qt5
cd build_qt5
ccmake ..
```

Since paths to present version of QT 5 was found, all of the QT 5 directories were found
* only install directory is needed

I assume here that the QT **qmake** was found

***
**Build and install**
<a name="build"/>

```c
make
```
If this runs without error
* **Note:** in this scenario **sudo** is not needed

```c
make install
```

The compiled libraries and the include files where added to the desired given directories:

```c
-- Installing: /home/mj10777/000_links/apps_local/libQt571/lib/libqca-qt5.so.2.1.3
-- Installing: /home/mj10777/000_links/apps_local/libQt571/lib/libqca-qt5.so.2
-- Installing: /home/mj10777/000_links/apps_local/libQt571/lib/libqca-qt5.so
...
-- Installing: /home/mj10777/000_links/apps_local/libQt571/include/Qca-qt5/QtCrypto/qca.h
-- Installing: /home/mj10777/000_links/apps_local/libQt571/include/Qca-qt5/QtCrypto/qcaprovider.h
-- Installing: /home/mj10777/000_links/apps_local/libQt571/include/Qca-qt5/QtCrypto/QtCrypto
-- Installing: /home/mj10777/000_links/apps_local/libQt571/include/Qca-qt5/QtCrypto/qca_export.h
-- Installing: /home/mj10777/000_links/apps_local/libQt571/include/Qca-qt5/QtCrypto/qca_support.h
-- Installing: /home/mj10777/000_links/apps_local/libQt571/include/Qca-qt5/QtCrypto/qca_tools.h
-- Installing: /home/mj10777/000_links/apps_local/libQt571/include/Qca-qt5/QtCrypto/qca_core.h
-- Installing: /home/mj10777/000_links/apps_local/libQt571/include/Qca-qt5/QtCrypto/qca_textfilter.h
-- Installing: /home/mj10777/000_links/apps_local/libQt571/include/Qca-qt5/QtCrypto/qca_basic.h
-- Installing: /home/mj10777/000_links/apps_local/libQt571/include/Qca-qt5/QtCrypto/qca_publickey.h
-- Installing: /home/mj10777/000_links/apps_local/libQt571/include/Qca-qt5/QtCrypto/qca_cert.h
-- Installing: /home/mj10777/000_links/apps_local/libQt571/include/Qca-qt5/QtCrypto/qca_keystore.h
-- Installing: /home/mj10777/000_links/apps_local/libQt571/include/Qca-qt5/QtCrypto/qca_securelayer.h
-- Installing: /home/mj10777/000_links/apps_local/libQt571/include/Qca-qt5/QtCrypto/qca_securemessage.h
-- Installing: /home/mj10777/000_links/apps_local/libQt571/include/Qca-qt5/QtCrypto/qca_version.h
-- Installing: /home/mj10777/000_links/apps_local/libQt571/include/Qca-qt5/QtCrypto/qpipe.h
-- Installing: /home/mj10777/000_links/apps_local/libQt571/include/Qca-qt5/QtCrypto/qca_safetimer.h
```


***

**QGIS 3 ccmake parms**
<a name="qgis_ccmake_parms"/>

For the QGIS 3 Project, these values for the library and include directories must be properly set using **ccmake**:

* **QCA_INCLUDE_DIR** : /home/mj10777/000_links/apps_local/libQt571/include/Qca-qt5/QtCrypto
* **QCA_LIBRARY** : /home/mj10777/000_links/apps_local/libQt571/lib/**libqca-qt5.so**

---
2017-03-18: Mark Johnson, Berlin Germany

---