# Building QScintilla - Version 2.10
[<-- Main 'Table of content'](Home#table_of_content)
 
[<-- 'Building of QGIS 3.* versions'](Building-QGIS-3#topics)

[<-- 'Building QGIS 3.0 from scratch'](Building-QGIS-3.0-from-scratch#topics)

[<-- 'Building QT 5 from scratch'](Building-QT-5-from-scratch#topics)


***


[--> 'Download the source'](#download_source)

[--> 'Configuration'](#configuration)

[--> 'Build and install'](#build)

[--> 'QGIS 3 ccmake parms'](#qgis_ccmake_parms)

---

The original instructions can be found here:
* ['QScintilla - a Port to Qt v4 and Qt v5 of Scintilla'](http://pyqt.sourceforge.net/Docs/QScintilla2/index.html)

---

**Download the source**
<a name="download_source"/>

The source code can be downloaded from this site:
* ['Sourceforge - PyQT'](https://sourceforge.net/projects/pyqt/files/QScintilla2/QScintilla-2.10/)

or with the wget command:
* `wget https://sourceforge.net/projects/pyqt/files/QScintilla2/QScintilla-2.10/QScintilla_gpl-2.10.tar.gz`

***
Unpack the source from the archive.

***
**Configuration**
<a name="configuration"/>

**Note:** pre-condition is that: **QT 5** has been installed and
* that the the all important **qmake** is available
   * in my case in */home/mj10777/000_links/apps_local/libQt571/bin/qmake*
* [that SIP has been installed](Building-SIP-for-QT-5)

Enter **Python** directory, inside the directory when the source-code was unpacked
```c
cd QScintilla_gpl-2.10/Python
```

Inside this directory, you should find:
* **configure.py**

With
**python3 configure.py --help**  all of the available parameters can be listed, such as:

* **--destdir** [where the results should be stored]
* **--sip-incdir** [where the **sip** include files are stored]
* **--qmake** [where the all important **qmake** is stored]
* **--pyqt-sipdir** [where the created **sip** files are to be stored]
* **–-pyqt** [for which QT-Version is to be used (default: **PyQt4**]
   * **Note:** for me this parameter **fails** to work, the script returns the help-information
      * For **PyQt5**, I had to change the configure.py script (line 95) 
         * from **pyqt5_is_default = False** to **pyqt5_is_default = True**

```c
/home/mj10777/000_links/apps_local/libQt571/bin/python3 configure.py --destdir=/home/mj10777/000_links/apps_local/libQt571/lib/python3.4/site-packages/PyQt5 --sip-incdir=/home/mj10777/000_links/apps_local/libQt571/include/python3.4m  --qmake=/home/mj10777/000_links/apps_local/libQt571/bin/qmake --pyqt-sipdir=/home/mj10777/000_links/apps_local/libQt571/share/sip/PyQt5
```

The script will issue message that will look something like this:

```c
Configuring QScintilla 2.10...
QScintilla 2.10 is being used.
The QScintilla .sip files will be installed in
/home/mj10777/000_links/apps_local/libQt571/share/sip/PyQt5.
QScintilla will be installed in
/home/mj10777/000_links/apps_local/libQt571/lib/python3.4/site-packages/PyQt5.
PyQt 5.8.1 is being used.
Qt 5.7.1 is being used.
sip 4.19.1 is being used.
The sip executable is /home/mj10777/000_links/apps_local/libQt571/bin/sip.
QScintilla is being built with 'protected' redefined as 'public'.
The PEP 484 stubs will be installed in
/home/mj10777/000_links/apps_local/libQt571/lib/python3.4/site-packages/PyQt5.
The QScintilla API file will be installed in
/home/mj10777/000_links/apps_local/libQt571/qsci/api/python.
```

***

**Build and install**
<a name="build"/>

```c
make
```

If this runs without error
* **Note:** in this scenario **sudo** is not needed

```c
make install
```

***

**QGIS 3 ccmake parms**
<a name="qgis_ccmake_parms"/>

For the QGIS 3 Project, these values for the library and include directories must be properly set using **ccmake**:

* **QSCINTILLA_INCLUDE_DIR** : /home/mj10777/000_links/apps_local/libQt571/include
* **QSCINTILLA_LIBRARY** : /home/mj10777/000_links/apps_local/libQt571/lib/**libqscintilla2_qt5.so**

---
2017-03-18: Mark Johnson, Berlin Germany

---