[<-- Main 'Table of content'](Home#table_of_content)
 
[<-- 'Building of QGIS 3.* versions'](Building-QGIS-3#topics)

[<-- 'Building QGIS 3.0 from scratch'](Building-QGIS-3.0-from-scratch#topics)

[<-- 'Building QT 5 from scratch'](Building-QT-5-from-scratch#topics)


***


[--> 'Download the source'](#download_source)

[--> 'Configuration'](#configuration)

[--> 'Build and install'](#build)

---

The original instructions can be found here:
* ['Building Qt 5 from Git'](https://wiki.qt.io/Building_Qt_5_from_Git)
   * search for **Getting the source code**

***

**Download the source**
<a name="download_source"/>

**Step 1**) create the directory where the QT 5 5.7.1 source should be stored:

```c
mkdir git_qt_5.7.1
cd git_qt_5.7.1
```

**Step 2**) Clone the git repository:
```c
git clone git://code.qt.io/qt/qt5.git
```

You should now have a **qt5** directory
```c
cd qt5
```

**Step 3**) checkout the QT version needed (here 5.7.1)
* with `git tag` you can list the available tags

```c
git tag | grep 5.7

v5.7.0
v5.7.0-alpha1
v5.7.0-beta1
v5.7.0-rc1
v5.7.1
```

Since we want version 5.7.1
* the tag-name **v5.7.1** must be used

```c
git checkout v5.7.1
```

**Step 4**) checkout the QT sub-modules for the checked out version (here 5.7.1)
* this will take a while to complete

```c
git submodule update --init

Submodul 'qt3d' (git://code.qt.io/qt/qt3d.git) für Pfad 'qt3d' in die Konfiguration eingetragen.
Submodul 'qtactiveqt' (git://code.qt.io/qt/qtactiveqt.git) für Pfad 'qtactiveqt' in die Konfiguration eingetragen.
...
Submodul 'qtwebkit' (git://code.qt.io/qt/qtwebkit.git) für Pfad 'qtwebkit' in die Konfiguration eingetragen.
...
Klone nach 'qtwebkit'...
remote: Counting objects: 116473, done.
remote: Compressing objects: 100% (32929/32929), done.
remote: Total 116473 (delta 89508), reused 100941 (delta 82530)
Empfange Objekte: 100% (116473/116473), 139.01 MiB | 2.50 MiB/s, Fertig.
Löse Unterschiede auf: 100% (89508/89508), Fertig.
Prüfe Konnektivität... Fertig.
Submodul-Pfad: 'qtwebkit': 'b9ce7cfc7f14b96b0b573f56f792fb3a55ac60f9' ausgecheckt
...
```

At this point you should have all of the needed sub-modules needed for QT 5.7.1
* including **QtWebKit**

***

**Configuration**
<a name="configuration"/>

With
**./configure --help**  all of the available parameters can be listed, such as:

* **-confirm-license** [sparing the need to confirm the license]
* **-opensource** [sparing the need to select the type of license]
* **-qt-libpng** [use internal **libpng**, which can avoid conflicts with any other versions]
* **-qt-libjpeg** [use internal **libjpeg**, which can avoid conflicts with any other versions]
* **-nomake examples** [do not build examples, when not needed]
* **-nomake tests** [do not build tests, when not needed]
* **-qt-pcre** [use the builtin pcre-library, whatever that may be]
* **-prefix** [where the result should be installed, default: **/usr/local/Qt-5.7.1**]
* **-release** [build the release version, when **debug** is not needed]

```c
./configure -confirm-license -opensource -qt-libpng -qt-libjpeg -nomake examples -nomake tests -qt-pcre -prefix /home/mj10777/000_links/apps_local/libQt571 -release
```

This will take some time to complete, after-which a summery
* and will start by building the all important **qmake**

```c
Creating qmake...
.........................................................................................Done.
```

With a final report:
* if nothing fails

```c
Qt is now configured for building. Just run 'make'.
Once everything is built, you must run 'make install'.
Qt will be installed into /home/mj10777/000_links/apps_local/libQt571
```

***

**Build and install**
<a name="build"/>

```c
make
```

And after a good 24 hours (on my 6 year old machine)
* with no errors

You can the install the results with:
* **Note:** in this scenario **sudo** is not needed

```c
make install
```

---
2017-03-18: Mark Johnson, Berlin Germany

---