# Building Qwt - Version 6.1.3
[<-- Main 'Table of content'](Home#table_of_content)
 
[<-- 'Building of QGIS 3.* versions'](Building-QGIS-3#topics)

[<-- 'Building QGIS 3.0 from scratch'](Building-QGIS-3.0-from-scratch#topics)

[<-- 'Building QT 5 from scratch'](Building-QT-5-from-scratch#topics)


***


[--> 'Download the source'](#download_source)

[--> 'Configuration'](#configuration)

[--> 'Build and install'](#build)

[--> 'QGIS 3 ccmake parms'](#qgis_ccmake_parms)

---

The original instructions can be found here:
* ['Qwt User's Guide  6.1.3'](http://qwt.sourceforge.net/qwtinstall.html)

---

**Download the source**
<a name="download_source"/>

The source code can be downloaded from this site:
* ['Sourceforge - Qwt'](https://sourceforge.net/projects/qwt/files/qwt/6.1.3/)

or with the wget command:
* `wget https://sourceforge.net/projects/qwt/files/qwt/6.1.3/qwt-6.1.3.tar.bz2`

***
Unpack the source from the archive.

***
**Configuration**
<a name="configuration"/>

**Note:** pre-condition is that: **QT 5** has been installed and
* that the the all important **qmake** is available
   * in my case in */home/mj10777/000_links/apps_local/libQt571/bin/qmake*

Enter the directory when the source-code was unpacked
```c
cd qwt-6.1.3
```

Inside this directory, you should find:
* **qwt.pro**

Together with **qmake**,**qwt.pro** will be used to create the needed **Makefile** 

```c
/home/mj10777/000_links/apps_local/libQt571/bin/qmake qwt.pro
```

The default setting of qmake seems to generate a makefile that builds Qwt 
* for the same environment where the version of qmake has been built for

In this case it was installed here:

```c
/home/mj10777/000_links/apps_local/libQt571/qwt-6.1.3

/home/mj10777/000_links/apps_local/libQt571/qwt-6.1.3/include
/home/mj10777/000_links/apps_local/libQt571/qwt-6.1.3/lib
```

To simplify the installation
* I copied the files inside **qwt-6.1.3/lib**
  * to **libQt571/lib**

***

**Build and install**
<a name="build"/>

```c
make
```

If this runs without error
* **Note:** in this scenario **sudo** is not needed

```c
make install
```

***

**QGIS 3 ccmake parms**
<a name="qgis_ccmake_parms"/>

For the QGIS 3 Project, these values for the library and include directories must be properly set using **ccmake**:

* **QWT_INCLUDE_DIR** : /home/mj10777/000_links/apps_local/libQt571/qwt-6.1.3/include
* **QWT_LIBRARY** : /home/mj10777/000_links/apps_local/libQt571/lib/**libqwt.so**

---
2017-03-18: Mark Johnson, Berlin Germany

---