# Building SIP - Version 4.19.1
[<-- Main 'Table of content'](Home#table_of_content)
 
[<-- 'Building of QGIS 3.* versions'](Building-QGIS-3#topics)

[<-- 'Building QGIS 3.0 from scratch'](Building-QGIS-3.0-from-scratch#topics)

[<-- 'Building QT 5 from scratch'](Building-QT-5-from-scratch#topics)


***


[--> 'Download the source'](#download_source)

[--> 'Configuration'](#configuration)

[--> 'Build and install'](#build)

[--> 'QGIS 3 ccmake parms : none'](#qgis_ccmake_parms)

---

The original instructions can be found here:
* ['SIP 4.19.1 Reference Guide'](http://pyqt.sourceforge.net/Docs/sip4/installation.html)

---

**Download the source**
<a name="download_source"/>

The source code can be downloaded from this site:
* ['SIP Download'](https://riverbankcomputing.com/software/sip/download)

or with the wget command:
* `wget https://sourceforge.net/projects/pyqt/files/sip/sip-4.19.1/sip-4.19.1.tar.gz`

***
Unpack the source from the archive.

***
**Configuration**
<a name="configuration"/>

**Notes:** this packege is a pre-condition for
* the building of:
   * [Building QScintilla - Version 2.10](Building-QScintilla-for-QT-5)
   * [Building PyQt5 - Version 5.8.1](Building-PyQt5-for-QT-5)
* and may already be installed

Enter the directory when the source-code was unpacked
```c
cd sip-4.19.1
```

Inside this directory, you should find:
* **configure.py**

With
**python3 configure.py --help**  all of the available parameters can be listed, such as:

* **--bindir** [where the binary results should be stored]
* **--destdir** [where the python results should be stored]
* **--incdir** [where the **sip** include files are stored]
* **--stubsdir** [where the *stubs* results should be stored (whatevery they may be)]
* **--sipdir** [where the created **sip** files are to be stored]

```c
/home/mj10777/000_links/apps_local/libQt571/bin/python3 configure.py  --bindir=/home/mj10777/000_links/apps_local/libQt571/bin --destdir=/home/mj10777/000_links/apps_local/libQt571/lib/python3.4/site-packages --sipdir=/home/mj10777/000_links/apps_local/libQt571/share/sip --stubsdir=/home/mj10777/000_links/apps_local/libQt571/lib/python3.4/site-packages --incdir=/home/mj10777/000_links/apps_local/libQt571/include/python3.4m
```

The script will issue message that will look something like this:

```c
This is SIP 4.19.1 for Python 3.4.6 on linux.
The SIP code generator will be installed in
/home/mj10777/000_links/apps_local/libQt571/bin.
The sip module will be installed in
/home/mj10777/000_links/apps_local/libQt571/lib/python3.4/site-packages.
The sip.pyi stub file will be installed in
/home/mj10777/000_links/apps_local/libQt571/lib/python3.4/site-packages.
The sip.h header file will be installed in
/home/mj10777/000_links/apps_local/libQt571/include/python3.4m.
The default directory to install .sip files in is
/home/mj10777/000_links/apps_local/libQt571/share/sip.

```

***

**Build and install**
<a name="build"/>

```c
make
```

If this runs without error
* **Note:** in this scenario **sudo** is not needed

```c
make install
```

***

**QGIS 3 ccmake parms**
<a name="qgis_ccmake_parms"/>

* none

---
2017-03-18: Mark Johnson, Berlin Germany

---